[PACKAGE]: ../../raw/master/mkp/bgp_topology-0.0.3-20240104.mkp "bgp_topology-0.0.3-20240104.mkp"
# BGP Topology

This plugin will create a Network Visualization Topology from the Peer relations of your _BGP peer services_ in Checkmk. 

**Note**: This check is an active check and needs to be associated with one of the hosts in Checkmk. Usually a host with BGP peers.

---
### Download
* [Download latest mkp file][PACKAGE]

**Note**: before you update to a newer version, always check the [CHANGELOG](CHANGELOG). There migth be incompatible changes.
                        
---
### Installation

You can install the package by uploading it to your CheckMK site and as site user run 
```
mkp add PAKAGE_NAME.mkp
mkp enable PAKAGE_NAME VERSION
```

In the Enterprise/Free/Cloud edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

---
### Want to Contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_BGP Topology_** 

<details><summary>Montoring states</summary>

The service state is always ok.

</details>

<details><summary>Perfdata</summary>

| Metric | Unit | Perfometer |
| ------ | ------ | ------ |
| Time take | s | yes |

</details>

---
### WATO
<details><summary>Active check rule (HTTP, TCP, Email, ...)</summary>

| Section | Rule name |
| ------ | ------ |
| Networking | BGP Topology |

| Option | Defailt value | Options |
| ------ | ------ |----|
| Anchor for external BGP objects | Both | AS, ID, Both |
| BGP AS emblem | icon_cloud | None, Default, Custom |
| BGP ID emblem | icon_topic_system | None, Default, Custom |
| Make default | Disabled | Enabled, Disabled|
| Filter Checkmk sites| None | Include/Exclude sites |

</details> 

<details><summary>Discovery rule</summary>
There is no service discovery rule
</details> 

<details><summary>HW/SW inventory rules</summary>
There is no inventory rule.
</details> 

---
### Usage
<details><summary>Help output from check_bgp_topology --help</summary>

```
OMD[build]:~$ ~/local/lib/python3/cmk_addons/plugins/bgp_topology/libexec/check_bgp_topology --help
usage: bgp_topology [-h] [--bgp-anchor {both,as,id,none}] [--bgp-emblem-as BGP_EMBLEM_AS] [--bgp-emblem-id BGP_EMBLEM_ID] [--make-default] --host HOST [--include-sites INCLUDE_SITES [INCLUDE_SITES ...] | --exclude-sites EXCLUDE_SITES [EXCLUDE_SITES ...]] [--debug]

Create BGP peer network topology for Checkmk

options:
  -h, --help            show this help message and exit
  --bgp-anchor {both,as,id,none}
                        Anchor for external BGP objects (default: both).
  --bgp-emblem-as BGP_EMBLEM_AS
                        Emblem to use for BGP-AS objects (default: icon_cloud).
  --bgp-emblem-id BGP_EMBLEM_ID
                        Emblem to use for BGP-ID objects (default: icon_topic_system).
  --make-default        Make this topology the default (default: False).
  --host HOST           The name of the Checkmk host to which the plugin is attached. This is set 
                        automatically by Checkmk. If a site filter is active, the host name is 
                        appended to the subdirectory where the topology is stored (“BGP” becomes 
                        “BGP_host_name”). This way we can have more than one BGP topology without 
                        overwriting each other.
  --include-sites INCLUDE_SITES [INCLUDE_SITES ...]
                        List of Checkmk site names to include in the topology creation. 
                        Can not used together with --exclude-sites
  --exclude-sites EXCLUDE_SITES [EXCLUDE_SITES ...]
                        List of Checkmk site names to exclude from the topology creation. 
                        Can not used together with --include-sites
  --debug               enable debug output

Example usage:
~/local/lib/python3/cmk_addons/plugins/bgp_topology/libexec/check_bgp_topology --make-default --host bgp1        

Version: 0.0.2-20241223 | Written by thl-cmk[at]outlook[dot]com
for more information see: https://thl-cmk.hopto.org/gitlab/checkmk/vendor-independent/bgp_topology
        
OMD[build]:~$ 

```

</details>

---
### Sample Output

Sample output

![sample output](img/sample.png?raw=true "Sample output")

Sample BGP Topology

![sample bgp topology](img/sample-topology.png?raw=true "Sample BGP Topology")

